//==========================================================
// SxSFXGravityExplosion.uc
// November 10, 2006
// Created by SolidxSnake
//==========================================================
class SxSFXGravityExplosion extends P2Emitter;

var bool bAllowDestroy;

var() float GravityReach;  //How far can this thing reach players
var() float GravityForce;  //0.00 - 0.15 or else it's overpowered
var() int MaxCapacity; // How many players it can suck up before it'll die

var int GravityQuantity;

function Touch(Actor Other)
{
  if (Other != Instigator && Other != Owner && Other.bHidden == False)
    {
      Other.TakeDamage(666, Instigator, Location, Other.Velocity, class'SxSGravityDamage');
      if ( Other.IsA('Pawn'))
        GravityQuantity ++;
    }
  if (GravityQuantity >= MaxCapacity)
    {
      DieEffect();
    }
}

function Tick(float DeltaTime)
{
 local vector ApplyVel;
 local Actor Other;
 local float Dist;

   foreach RadiusActors(class'Actor',Other,GravityReach)
     {
       if (Other != Instigator && Other != Owner && Other.bHidden == False && Other != Self && !Other.IsA('SxSFXGravityHole') &&
        (Other.Physics == PHYS_Trailer || Other.Physics == PHYS_Projectile || Other.Physics == PHYS_Flying
         || Other.Physics == PHYS_Swimming || Other.Physics == PHYS_Swimming || Other.Physics == PHYS_Falling
         || Other.Physics == PHYS_Swimming || Other.Physics == PHYS_Walking || Other.Physics == PHYS_None
          || Other.Physics == PHYS_Karma || Other.Physics == PHYS_KarmaRagDoll))
            {
              Dist = VSize(Location - Other.Location);
               if(Dist <= GravityReach)
                 {
                   ApplyVel = GravityForce * (Location - Other.Location);
                   Other.Velocity += ApplyVel;
                 }
            }
     }
}

function PostBeginPlay()
{
 Super.PostBeginPlay();
 SetTimer(0.25,true);
}

function DieEffect()
{
  Emitters[0].RespawnDeadParticles=False;
  Emitters[1].RespawnDeadParticles=False;
}

function Timer()
{
  Emitters[0].StartSizeRange.X.Min += 10;
  Emitters[0].StartSizeRange.X.Max += 10;
  if (Emitters[0].StartSizeRange.X.Min >= 300)
    {
      GotoState('DieBitch');
    }
}

state DieBitch
{
  function BeginState()
    {
      Emitters[0].RespawnDeadParticles = False;
      SetTimer(0.5,false);
    }
  function Timer()
    {
      Destroy();
    }
BEGIN:
Emitters[0].RespawnDeadParticles = False;
}

defaultproperties
{
 MaxCapacity=3
 GravityForce=0.10
 GravityReach=500
 bCollideActors=True
     Begin Object Class=SpriteEmitter Name=GravityExplosion
         Texture=Texture'nathans.Skins.blast1'
         DrawStyle=PTDS_Darken
         LifetimeRange=(Min=0.5,Max=0.5)
         MaxParticles=50
         StartLocationShape=PTLS_Shape
         SphereRadiusRange=(Min=125,Max=25)
         UseSizeScale=True
         UseRegularSizeScale=True
         StartSizeRange=(X=(Min=25,Max=25))
         StartLocationShape=PTLS_Sphere
         SphereRadiusRange=(Min=1,Max=40)
         CoordinateSystem=PTCS_Relative
     End Object
     Emitters(0)=SpriteEmitter'SnakesArsenal-1.GravityExplosion'
}
