//==========================================================
// SxSFXGravityHole.uc
// November 10, 2006
// Created by SolidxSnake
//==========================================================
class SxSFXGravityHole extends P2Emitter;

var() float GravityReach;  //How far can this thing reach players
var() float GravityForce;  //0.00 - 0.15 or else it's overpowered
var() int MaxCapacity; // How many players it can suck up before it'll die

var int GravityQuantity;

function Touch(Actor Other)
{
  if (Other != Instigator && Other != Owner && Other.bHidden == False)
    {
      Other.TakeDamage(666, Instigator, Location, Other.Velocity, class'SxSGravityDamage');
      if ( Other.IsA('Pawn'))
        GravityQuantity ++;
    }
  if (GravityQuantity >= MaxCapacity)
    {
      DieEffect();
    }
}

function Tick(float DeltaTime)
{
 local vector ApplyVel;
 local Actor Other;
 local float Dist;

   foreach RadiusActors(class'Actor',Other,GravityReach)
     {
       if (Other.bHidden == False && Other != Self && !Other.IsA('SxSFXGravityHole') &&
        (Other.Physics == PHYS_Trailer || Other.Physics == PHYS_Projectile || Other.Physics == PHYS_Flying
         || Other.Physics == PHYS_Swimming || Other.Physics == PHYS_Swimming || Other.Physics == PHYS_Falling
         || Other.Physics == PHYS_Swimming || Other.Physics == PHYS_Walking || Other.Physics == PHYS_None
          || Other.Physics == PHYS_Karma || Other.Physics == PHYS_KarmaRagDoll))
            {
              Dist = VSize(Location - Other.Location);
               if(Dist <= GravityReach)
                 {
                   ApplyVel = GravityForce * (Location - Other.Location);
                   Other.Velocity += ApplyVel;
                 }
            }
     }
}

function DieEffect()
{
  Emitters[0].RespawnDeadParticles=False;
  Emitters[1].RespawnDeadParticles=False;
  SetTimer(1,false);
}

function Timer()
{
  Destroy();
}

defaultproperties
{
 MaxCapacity=3
 GravityForce=0.10
 GravityReach=700
 bCollideActors=True
     Begin Object Class=SpriteEmitter Name=GravityHoleCore
         Texture=Texture'nathans.Skins.blast1'
         DrawStyle=PTDS_Darken
         LifetimeRange=(Min=0.5,Max=0.5)
         MaxParticles=150
         FadeIn=True
         FadeInEndTime=1
         StartLocationShape=PTLS_Shape
         SphereRadiusRange=(Min=0,Max=100)
         UseSizeScale=True
         UseRegularSizeScale=False
         StartSizeRange=(X=(Min=25,Max=25))
         StartLocationShape=PTLS_Sphere
         SphereRadiusRange=(Min=1,Max=40)
         CoordinateSystem=PTCS_Relative
     End Object
     Emitters(0)=SpriteEmitter'SnakesArsenal-1.GravityHoleCore'

     Begin Object Class=SpriteEmitter Name=GravityHoleSpace
         Texture=Texture'nathans.Skins.Bubble'
         DrawStyle=PTDS_Darken
         LifetimeRange=(Min=0.2,Max=0.2)
         MaxParticles=50
         FadeIn=True
         FadeInEndTime=1
         StartLocationShape=PTLS_Shape
         SphereRadiusRange=(Min=0,Max=100)
         UseSizeScale=True
         UseRegularSizeScale=False
         StartSizeRange=(X=(Min=75,Max=75))
         StartLocationShape=PTLS_Sphere
         SphereRadiusRange=(Min=1,Max=100)
     End Object
     Emitters(1)=SpriteEmitter'SnakesArsenal-1.GravityHoleSpace'
}
