//==========================================================
// SxSFXGravityRepel.uc
// November 10, 2006
// Created by SolidxSnake
//==========================================================
class SxSFXGravityRepel extends P2Emitter;

var() float GravityReach;  //How far can this thing reach players
var() float GravityForce;  //0.00 - 0.15 or else it's overpowered
var() int MaxCapacity; // How many players it can suck up before it'll die

var int GravityQuantity;

function Touch(Actor Other)
{
  if (Other != Instigator && Other != Owner && Other.bHidden == False)
    {
      Other.TakeDamage(666, Instigator, Location, Other.Velocity, class'SxSGravityDamage');
      if ( Other.IsA('Pawn'))
        GravityQuantity ++;
    }
  if (GravityQuantity >= MaxCapacity)
    {
      DieEffect();
    }
}

function Tick(float DeltaTime)
{
 local vector ApplyVel;
 local Actor Other;
 local float Dist;

   foreach RadiusActors(class'Actor',Other,GravityReach)
     {
       if (Other.bHidden == False && Other != Self && !Other.IsA('SxSFXGravityHole') &&
        (Other.Physics == PHYS_Trailer || Other.Physics == PHYS_Projectile || Other.Physics == PHYS_Flying
         || Other.Physics == PHYS_Swimming || Other.Physics == PHYS_Swimming || Other.Physics == PHYS_Falling
         || Other.Physics == PHYS_Swimming || Other.Physics == PHYS_Walking || Other.Physics == PHYS_None
          || Other.Physics == PHYS_Karma || Other.Physics == PHYS_KarmaRagDoll))
            {
              Dist = VSize(Location - Other.Location);
               if(Dist <= GravityReach)
                 {
                   ApplyVel = GravityForce * (Location - Other.Location);
                   Other.Velocity += ApplyVel;
                 }
            }
     }
}

function DieEffect()
{
  Emitters[0].RespawnDeadParticles=False;
  Emitters[1].RespawnDeadParticles=False;
  SetTimer(1,false);
}

function Timer()
{
  Destroy();
}

defaultproperties
{
 MaxCapacity=3
 GravityForce=-0.10
 GravityReach=700
 bCollideActors=True
     Begin Object Class=SpriteEmitter Name=GravityRepelCore
         Texture=Texture'nathans.Skins.blast1'
         LifetimeRange=(Min=0.5,Max=0.5)
         MaxParticles=15
         FadeIn=True
         FadeInEndTime=1
         UseSizeScale=True
         StartSizeRange=(X=(Min=25,Max=100))
         StartLocationShape=PTLS_Sphere
         SphereRadiusRange=(Min=1,Max=25)
         CoordinateSystem=PTCS_Relative
         UseColorScale=True
         ColorScale(0)=(Color=(A=255,B=255,G=255,R=255),RelativeTime=0)
         ColorScale(1)=(Color=(A=255,B=255,G=220,R=220),RelativeTime=1)
     End Object
     Emitters(0)=SpriteEmitter'SnakesArsenal-1.GravityRepelCore'

     Begin Object Class=SpriteEmitter Name=GravityRepelSpace
         Texture=Texture'nathans.Skins.Bubble'
         LifetimeRange=(Min=1,Max=1)
         MaxParticles=1000
         FadeIn=True
         FadeInEndTime=1
         UseSizeScale=True
         StartSizeRange=(X=(Min=1,Max=3))
         UseRegularSizeScale=False
         StartLocationShape=PTLS_Sphere
         SphereRadiusRange=(Min=100,Max=100)
         GetVelocityDirectionFrom=PTVD_AddRadial
         StartVelocityRadialRange=(Min=0,Max=400)
         UseColorScale=True
         ColorScale(0)=(Color=(A=255,B=255,G=255,R=255),RelativeTime=0)
         ColorScale(1)=(Color=(A=255,B=255,G=220,R=220),RelativeTime=1)
     End Object
     Emitters(1)=SpriteEmitter'SnakesArsenal-1.GravityRepelSpace'
}
