//==========================================================
// SxSGravityGun.uc
// November 10, 2006
// Created by SolidxSnake
//==========================================================
class SxSGravityGun extends P2Weapon;

// Need these four functions
simulated function PlayFiring()
{
  Super.PlayFiring();
  bForceReload=true;
}
simulated function PlayAltFiring()
{
  Super.PlayAltFiring();
  bForceReload=true;
}

simulated function LocalFire()
{
	local P2Player P;

	bPointing = true;

	if ( Affector != None )
		Affector.FireEffect();
	PlayFiring();
}

simulated function PlayReloading()
{
	// temp speed up because with no animation, you can't tell you're
	// why you can't shoot (becuase it's playing a reload anim)
	PlayAnim('Shoot1Unload', WeaponSpeedReload, 0.05);
	Instigator.PlayOwnedSound(ReloadSound, SLOT_Misc, 1.0);
}

simulated function PlayDownAnim()
{
	if(HasAmmo())
		Super.PlayDownAnim();
	else
		PlayAnim('HolsterEmpty', WeaponSpeedHolster, 0.05);
		Instigator.PlayOwnedSound(HolsterSound, SLOT_Misc, 1.0);
}

simulated function LocalAltFire()
{
	local PlayerController P;

	bPointing = true;

	if ( Affector != None )
		Affector.FireEffect();
	PlayAltFiring();
}


function ProjectileFire()
{
  //STUB
}

function ProjectileAltFire()
{
  //STUB
}

// This function's name will depend on your notify event in your animation browser
function Notify_ShootNapalm()
{
	local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
	local actor Other;
	local SxSProjectileGravity grav;
	local SxSProjectileAltGravity altgrav;
	local P2Player p2p;
	
	if(AmmoType != None
		&& AmmoType.HasAmmo())
	{
		GetAxes(Instigator.GetViewRotation(),X,Y,Z);
		StartTrace = GetFireStart(X,Y,Z); 
		AdjustedAim = Instigator.AdjustAim(AmmoType, StartTrace, 2*AimError);	
		//  Make sure there's nothing right in the way
		Other = Trace(HitLocation, HitNormal, Instigator.Location, StartTrace, true);
		if(Other == None
			|| (!Other.bStatic
				&& !Other.bWorldGeometry))
		{
                        if (bAltFiring)
			  altgrav = spawn(class'SxSProjectileAltGravity',Instigator,,StartTrace, AdjustedAim);
                        else
			  grav = spawn(class'SxSProjectileGravity',Instigator,,StartTrace, AdjustedAim);
			if(grav != None)
			{
				P2AmmoInv(AmmoType).UseAmmoForShot();
			}
			if(altgrav != None)
			{
				P2AmmoInv(AmmoType).UseAmmoForShot();
				P2AmmoInv(AmmoType).UseAmmoForShot();
			}
			// Touch any actor that was in between, just in case.
			if(Other != None)
				Other.Bump(grav);
		}
           
		// Shake the view when you fire it (Optional)
		if ( Instigator != None)
		{
			p2p = P2Player(Instigator.Controller);
			if (p2p!=None)
			{
				p2p.ClientShakeView(ShakeRotMag, ShakeRotRate, ShakeRotTime, 
							ShakeOffsetMag, ShakeOffsetRate, ShakeOffsetTime);
			}
		}
	}
}


// If you wish to create new states or replace states here for like (Idle, Active, DownWeapon)

defaultproperties
{
  InventoryGroup=1
  bUsesAltFire=True // If you want an Alt Fire
  ViolenceRank=4 // How violent this apparently is to NPCS
  RecognitionDist=500.000000 // How far away NPCS can see this weapon
  holdstyle=WEAPONHOLDSTYLE_Both // How your player holds the weapon in third person view
  switchstyle=WEAPONHOLDSTYLE_Both // How your player switches the weapon in third person view
  firingstyle=WEAPONHOLDSTYLE_Both // How your player fires the weapon in third person view
  bThrownByFiring=False // If this is a Projectile Weapon and if the weapon is the projectile itself, this should be set to true
  bBumpStartsFight=False // if you bump into an NPC while this weapon is drawn, they will fight you
  CombatRating=4 // same as ViolenceRank I guess
  FirstPersonMeshSuffix="Gravity" // This name should be your weapon name
  FireSound=Sound'WeaponSounds.cowhead_gas' // The Fire Sound
  AltFireSound=Sound'WeaponSounds.tazer_fire' // The Alt Fire Sound
  AmmoName=Class'SnakesArsenal-1.SxSGravityGunAmmoInv' // Your Ammo class
  FireOffset=(X=20.000000,Y=20.000000,Z=0.000000)
  ShakeRotMag=(X=400.000000)
  ShakeRotTime=2.500000
  ShakeOffsetMag=(X=20.000000,Y=3.000000,Z=3.000000)
  aimerror=300.000000 // Aim Error for bots (note this value doubled if instant hit weapon)
  ReticleTexture=Texture'P2Misc.Reticle.Reticle_Crosshair_Redline' // What your crosshair will display
  ReticleDefaultColor=(B=255,G=255,R=255,A=90) // What color and how transparant will your Crosshair display
  Skins(0)=Texture'MP_FPArms.LS_arms.LS_hands_dude'
  Skins(1)=Texture'Zo_Red_Tex.Other.zo_stars_static'
  Skins(2)=Texture'Zo_Skies.Sky1.zo_cloud2'
  Skins(3)=Texture'Zo_Skies.Sky1.zo_cloud2'
  Mesh=SkeletalMesh'MP_Weapons.MP_LS_Napalm'
  ItemName="Gravity Gun"
  AttachmentClass=Class'SnakesArsenal-1.SxSGravityGunAttachment'
  PickupClass=Class'SnakesArsenal-1.SxSGravityGunPickup'
  PlayerViewOffset=(X=1.700000,Z=-1.300000)
}
