//==========================================================
// SxSProjectileAltGravity.uc
// November 10, 2006
// Created by SolidxSnake
//==========================================================
class SxSProjectileAltGravity extends P2Projectile;

var SxSFXGravityRepel GravRepel;

var() float GravityReach;  //How far can this thing reach players
var() float GravityForce;  //0.00 - 0.15 or else it's overpowered

function Touch(Actor Other)
{
  if (Other != Instigator && Other != Owner && Other.bHidden == False)
    {
      Other.TakeDamage(10, Instigator, Location, Other.Velocity, class'SxSGravityDamage');
    }
}

simulated function PostBeginPlay()
{
 local vector Dir;

  Dir = vector(Rotation);
  Velocity = speed * Dir;
 
    if ( Level.NetMode != NM_DedicatedServer )
        GravRepel = spawn(class'SxSFXGravityRepel',Instigator); // Place your real Projectile (P2Emitter) class here

    Super.PostBeginPlay();
}

function Tick(float DeltaTime)
{
 local vector ApplyVel;
 local Actor Other;
 local float Dist;

   GravRepel.SetLocation(Location);
   
   foreach RadiusActors(class'Actor',Other,GravityReach)
     {
       if (Other.IsA('Pawn') || Other.IsA('Projectile') && Other != Instigator && Other != Owner && Other.bHidden == False && Other != Self && !Other.IsA('SxSFXGravityHole') &&
        (Other.Physics == PHYS_Trailer || Other.Physics == PHYS_Projectile || Other.Physics == PHYS_Flying
         || Other.Physics == PHYS_Swimming || Other.Physics == PHYS_Falling || Other.Physics == PHYS_Walking
          || Other.Physics == PHYS_None || Other.Physics == PHYS_Karma || Other.Physics == PHYS_KarmaRagDoll))
            {
              Dist = VSize(Other.Location - Location);
               if(Dist <= GravityReach)
                 {
                   ApplyVel = GravityForce * (Other.Location - Location);
                   Velocity += ApplyVel;
                 }
            }
     }
}

function HitWall(vector HitNormal, actor HitWall)
{
}

simulated function ProcessTouch(Actor Other, Vector HitLocation)
{
}

function Destroyed()
{
  GravRepel.DieEffect();
  Super.Destroyed();
}

defaultproperties
{
 GravityForce=0.07
 GravityReach=700
     bBounce=True
     LifeSpan=15
     bHidden=True
     DamageMP=0.000000 // How much damage to inflict (MultiPlayer)
     Speed=3000.000000  // Lowest Speed this projectile can go (Range)
     MaxSpeed=3000.000000 // Highest Speed this projectile can go (Range)
     Damage=0.000000 // How much damage to inflict (SinglePlayer)
     DamageRadius=25.000000 // How much damge to inflict in a radius, else set to 0
     MomentumTransfer=50000.000000  // How much momentum can this Projectile deal
     MyDamageType=Class'SnakesArsenal-1.SxSGravityDamage' // Your Damage Type
     DrawType=DT_StaticMesh // Your Draw Type, leave it alone
     Acceleration=(Z=0.000000)
     StaticMesh=StaticMesh'stuff.stuff1.Scissors' // Your Static Mesh to display for this projectile
     CollisionRadius=18.000000 // Collision Radius for this Projectile
     CollisionHeight=18.000000 // Collision Height for this Projectile
     bProjTarget=False // Projectile should potentially target actor, set this to true for projectile weapon I guess
     bUseCylinderCollision=True // Depending on your model
     bBounce=False // Bounces when hits ground fast.
     bFixedRotationDir=False // Fixes Rotation, Only if you want your projectile to rotate
}
