//==========================================================
// SxSProjectileGravity.uc
// November 10, 2006
// Created by SolidxSnake
//==========================================================
class SxSProjectileGravity extends P2Projectile;

var SxSFXGravityHole GravHole;

simulated function PostBeginPlay()
{
 local vector Dir;

  Dir = vector(Rotation);
  Velocity = speed * Dir;
 
    if ( Level.NetMode != NM_DedicatedServer )
        GravHole = spawn(class'SxSFXGravityHole',Instigator); // Place your real Projectile (P2Emitter) class here

    Super.PostBeginPlay();
}

function Tick(float DeltaTime)
{
  GravHole.SetLocation(Location);
}

function HitWall(vector HitNormal, actor HitWall)
{
  GravHole.DieEffect();
  spawn(class'SxSFXGravityExplosion',Instigator);
  Destroy();
}

simulated function ProcessTouch(Actor Other, Vector HitLocation)
{
  //STUB
}

function Destroyed()
{
  GravHole.DieEffect();
  Super.Destroyed();
}

defaultproperties
{
     LifeSpan=5
     bHidden=True
     DamageMP=0.000000 // How much damage to inflict (MultiPlayer)
     Speed=2000.000000  // Lowest Speed this projectile can go (Range)
     MaxSpeed=2000.000000 // Highest Speed this projectile can go (Range)
     Damage=0.000000 // How much damage to inflict (SinglePlayer)
     DamageRadius=25.000000 // How much damge to inflict in a radius, else set to 0
     MomentumTransfer=50000.000000  // How much momentum can this Projectile deal
     MyDamageType=Class'SnakesArsenal-1.SxSGravityDamage' // Your Damage Type
     DrawType=DT_StaticMesh // Your Draw Type, leave it alone
     Acceleration=(Z=-1500.000000)
     StaticMesh=StaticMesh'stuff.stuff1.Scissors' // Your Static Mesh to display for this projectile
     CollisionRadius=18.000000 // Collision Radius for this Projectile
     CollisionHeight=18.000000 // Collision Height for this Projectile
     bProjTarget=False // Projectile should potentially target actor, set this to true for projectile weapon I guess
     bUseCylinderCollision=True // Depending on your model
     bBounce=False // Bounces when hits ground fast.
     bFixedRotationDir=False // Fixes Rotation, Only if you want your projectile to rotate
}
